/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or
 * redistribute the software under the terms of the CeCILL license as
 * circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * As a counterpart to the access to the source code and rights to copy, modify
 * and redistribute granted by the license, users are provided only with a
 * limited warranty and the software's author, the holder of the economic
 * rights, and the successive licensors have only limited liability. In this
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally,
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 14 nov. 2007 17:44:27

import org.cocktail.carambole.server.MyAjaxPage;
import org.cocktail.carambole.server.NavigationCtrl;
import org.cocktail.fwkcktldepense.server.exception.FactoryException;
import org.cocktail.fwkcktldepense.server.metier.EOCommande;
import org.cocktail.fwkcktldepense.server.metier.EOExercice;
import org.cocktail.fwkcktldepense.server.process.ProcessCommande;

import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.eocontrol.EOEditingContext;

public class CommandeChoixDuplication extends MyAjaxPage {

	private static final long serialVersionUID = 1L;
	EOExercice unExercice = null;
	EOExercice exerciceDestination = null;

	public CommandeChoixDuplication(WOContext context) {
		super(context);
	}

	public EOExercice getUnExercice() {
		return unExercice;
	}

	public void setUnExercice(EOExercice unExercice) {
		this.unExercice = unExercice;
	}

	public EOExercice getExerciceDestination() {
		if (exerciceDestination == null) {
			exerciceDestination = session.accueilControleur().exerciceDuJour;
		}
		return exerciceDestination;
	}

	public void setExerciceDestination(EOExercice exerciceDestination) {
		this.exerciceDestination = exerciceDestination;
	}

	public WOComponent selectionnerExerciceDestination() {
		return null;
	}

	public Boolean isDroitEngager() {
		return Boolean.valueOf(laCommandeEnCours() != null && utilisateurInContext(laCommandeEnCours().editingContext()).isDroitEngager(laCommandeEnCours()));
	}

	public WOComponent dupliquer(boolean completement) {
		WOComponent nextPage = (DetailCommande) pageWithName("DetailCommande");
		EOCommande laCommandeADupliquer = laCommandeEnCours();
		EOEditingContext edc = laCommandeADupliquer.editingContext();
		EOExercice exercice = getExerciceDestination();
		EOCommande nouvelleCommande = null;
		try {
			if (exercice == null) {
				exercice = session.accueilControleur().exerciceDuJour;
			}
			nouvelleCommande = ProcessCommande.dupliquer(edc, laCommandeADupliquer, exercice.exerciceInContext(edc), utilisateurInContext(edc), completement, false);
			session.setLaCommandeEnCours(nouvelleCommande);
			if (isDroitEngager()) {
				nextPage = NavigationCtrl.goToBonDeCommande(context(), nouvelleCommande, null, BonDeCommande2.TAB_SOURCES);
			}
			else {
				nextPage = NavigationCtrl.goToBonDeCommande(context(), nouvelleCommande, null, BonDeCommande2.TAB_INFORMATIONS);
			}

		} catch (FactoryException e) {
			String alertMessage = e.getMessageFormatte();
			if (e.isBloquant()) {
				if (e.isInformatif()) {
					// Exception contenant un message d'information pour l'utilisateur
					((DetailCommande) nextPage).setLaCommande(laCommandeEnCours());
					session.setAlertMessage(alertMessage);
				}
				else {
					e.printStackTrace();
					throw e;
				}
			}
			else {
				session.setLaCommandeEnCours(nouvelleCommande);
				((BonDeCommande2) nextPage).setLaCommande(nouvelleCommande);
				((BonDeCommande2) nextPage).setSelectedTab("Sources");
				session.setAlertMessage(alertMessage);
			}
		} catch (RuntimeException e1) {
			session.setAlertMessage(e1.getMessage());
			e1.printStackTrace();
			throw e1;
		}
		return nextPage;
	}

	public WOComponent dupliquerCompletement() {
		return dupliquer(true);
	}

	public WOComponent dupliquerPartiellement() {
		return dupliquer(false);
	}

	public WOComponent annuler() {
		DetailCommande nextPage = (DetailCommande) pageWithName("DetailCommande");
		nextPage.setLaCommande(laCommandeEnCours());
		return nextPage;
	}
}